
/* Written by Peter Ekberg, peda@lysator.liu.se */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <stdio.h>
#include <string.h>

#include "thrust_types.h"
#include "keyboard.h"
#include "keys.h"
#include "font5x5.h"
#include "thrust.h"
#include "keyboard.h"
#include "gr_drv.h"

int
getscancode(int old, int x, int y)
{
  int result;
  static char str[40];
  int oldcolor;

  oldcolor=chcolor;
  sprintf(str, "%s", keystring(old));
  printgs(x, y, str);

  result = getonemultiplekey();
  if(!strcasecmp("ESCAPE", keystring(result)))
    result = old;
  chcolor=0;
  printgs(x, y, str);
  chcolor=oldcolor;
  sprintf(str, "%s", keystring(result));
  printgs(x, y, str);

  return(result);
}

void
changekeys()
{
  static char *descriptions[5] = {
    "TURN LEFT",
    "TURN RIGHT",
    "THRUST",
    "FIRE",
    "PICKUP & FUEL"
  };
  int i, end;
  char *keyname;

  gcenter(45, "CHANGE KEYS");
  chcolor--;
  for(i=0; i<5; i++) {
    printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
    printgs(161, 65+i*8, ":");
    printgs(167, 65+i*8, keystring(scancode[i]));
  }
  gcenter(125, "PRESS ENTER TO CHANGE A KEY");
  gcenter(132, "(DON'T USE Q OR P, THESE ARE TAKEN)");
  gcenter(139, "USE CURSOR UP/DOWN TO MOVE AROUND");
  gcenter(148, "PRESS ESCAPE FOR THE MAIN MENU");

  i=0;
  end=0;
  chcolor++;
  printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
  chcolor--;

  fade_in();

  do {
    /*
    do {
      usleep(20000L);
    } while(!keywaiting());
    */

    keyname = keystring(getonemultiplekey());

    if(!strcasecmp("CURSOR UP", keyname)
       || !strcasecmp("KEYPAD UP", keyname)
       || !strcasecmp("UP", keyname)
       || !strcasecmp("KP UP", keyname)) {
      printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
      i=(i+4)%5;
    }

    if(!strcasecmp("CURSOR DOWN", keyname)
       || !strcasecmp("KEYPAD DOWN", keyname)
       || !strcasecmp("DOWN", keyname)
       || !strcasecmp("KP DOWN", keyname)) {
      printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
      i=(i+1)%5;
    }

    if(!strcasecmp("ENTER", keyname)
       || !strcasecmp("KEYPAD ENTER", keyname)
       || !strcasecmp("KP ENTER", keyname)
       || !strcasecmp("RETURN", keyname)) {
      printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);

      chcolor++;
      displayscreen();
      scancode[i]=getscancode(scancode[i], 167, 65+i*8);
      printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
      chcolor--;

      printgs(167, 65+i*8, keystring(scancode[i]));
      displayscreen();

      /*
      do {
	usleep(20000L);
      } while(keywaiting());
      */
    }

    if(!strcasecmp("ESCAPE", keyname)
       || !strcasecmp("Q", keyname)) {
      end=1;
    }

    chcolor++;
    printgs(160-gstrlen(descriptions[i]), 65+i*8, descriptions[i]);
    chcolor--;

    displayscreen();
    /*
    for(j=0; j<15; j++) {
      usleep(10000L);
      if(!keywaiting())
	j=25;
    }
    */
  } while(!end);
  
/*
  do {
    usleep(20000L);
  } while(keywaiting());
  */

  chcolor++;
  
  fade_out();
}
